<template>
	<p
		v-if="isUSWebsite"
		class="affirm-as-low-as"
		:data-page-type="pageType"
		:data-affirm-color="color"
		:data-amount="priceNormalized"
	/>
</template>

<script>
import debounce from 'lodash/debounce';
import { mapState } from 'vuex';

const hasAffirm = () => Boolean(window.affirm && window.affirm.ui && window.affirm.ui.refresh);

const affirmRefresh = debounce(() => {
	window.affirm.ui.ready(function () {
		window.affirm.ui.refresh();
	});
}, 50);

export default {
	props: {
		price: {
			type: [Number, String],
			required: true,
		},

		color: {
			type: String,
			default: 'black',
		},

		pageType: {
			type: String,
			default: 'cart',
		},
	},

	computed: {
		...mapState(['isUSWebsite']),

		priceNormalized() {
			return this.price * 100;
		},
	},

	watch: {
		price() {
			if (hasAffirm()) {
				affirmRefresh();
			}
		},
	},

	mounted() {
		if (!this.isUSWebsite) return;

		if (hasAffirm()) {
			affirmRefresh();
		}

		this.observer = new MutationObserver(() => {
			this.addTracking();
			const firstChild = this.$el.firstElementChild;
			if (!firstChild || firstChild.classList.contains('mutation-emited')) return;
			firstChild.classList.add('mutation-emited');
			this.$emit('update', this.$el);
		});

		this.observer.observe(this.$el, { childList: true });
	},

	beforeDestroy() {
		if (this.observer) {
			this.observer.disconnect();
		}
	},

	methods: {
		addTracking() {
			const link = this.$el && this.$el.querySelector('a.affirm-modal-trigger');
			if (!link) return;
			link.addEventListener('click', this.trackClick, false);
		},

		trackClick() {
			this.$tealiumEvent('cta_affirmLearnMore_click', {
				event_category: 'Affirm',
				event_action: 'Clicked Affirm Learn More',
			});
		},
	},
};
</script>
